<template>
  <div>
    <rui-loading v-if="loading" :text="$t('generic.loading')" />
    <rui-alert v-else-if="notesError" variant="warning">{{ $t('js.resources.description_area.user_notes_loading_error') }}</rui-alert>
    <rui-empty v-else-if="notes.length === 0" :content="$t('js.resources.description_area.no_user_note')" inline />
    <div v-else>
      <gpa-resource-note v-for="note in notes" :key="note.id" :resource-note="note" />
    </div>
  </div>
</template>

<script>
import RuiAlert from '@experiments-labs/rise_ui/src/components/Alert/Alert.vue'
import RuiEmpty from '@experiments-labs/rise_ui/src/components/DataDisplay/Empty/Empty.vue'
import RuiLoading from '@experiments-labs/rise_ui/src/components/Loading/Loading.vue'

import Resource from '../../../../classes/models/Resource'
import GpaResourceNote from '../ResourceNotes/_ResourceNote.vue'

export default {
  name: 'GpaResourceNotes',
  components: { GpaResourceNote, RuiEmpty, RuiAlert, RuiLoading },
  props: {
    resource: { required: true, type: Resource },
  },
  data () {
    return {
      notesError: false,
      loading: false,
    }
  },
  computed: {
    notes () { return this.$props.resource.notes },
    account () { return this.$store.getters.account },
  },
  methods: {
    loadNotes () {
      this.loading = true
      this.notesError = false

      this.$store.dispatch('loadResourceNotes', this.$props.resource.id)
        .catch(() => { this.notesError = true })
        .then(() => { this.loading = false })
    },
  },
  created () {
    this.loadNotes()
  },
}
</script>
